﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Runtime.Serialization;

namespace HeuristicLab.Services.Deployment.DataAccess {
  [DataContract(Name = "PluginDescription")]
  public class PluginDescription {

    [DataMember(Name = "Id")]
    private long id;
    internal long Id {
      get {
        return id;
      }
      set {
        id = value;
      }
    }

    [DataMember(Name = "Name")]
    private string name;
    public string Name {
      get { return name; }
    }

    [DataMember(Name = "Version")]
    private Version version;
    public Version Version {
      get { return version; }
    }


    [DataMember(Name = "Dependencies")]
    private List<PluginDescription> dependencies;
    public List<PluginDescription> Dependencies {
      get { return dependencies; }
    }

    //[DataMember(Name = "IsDatabaseInstance")]
    //private bool isDatabaseInstance;
    //internal bool IsDatabaseInstance {
    //  get {
    //    return isDatabaseInstance;
    //  }
    //}

    internal PluginDescription(long id, string name, Version version, IEnumerable<PluginDescription> dependencies) {
      this.id = id;
      this.name = name;
      this.version = version;
      this.dependencies = new List<PluginDescription>(dependencies); //.AsReadOnly();
      //this.isDatabaseInstance = true;
    }

    public PluginDescription(string name, Version version, IEnumerable<PluginDescription> dependencies)
      : this(0, name, version, dependencies) {
      //this.isDatabaseInstance = false;
    }

    public PluginDescription(string name, Version version)
      : this(name, version, Enumerable.Empty<PluginDescription>()) {
      //this.isDatabaseInstance = false;
    }
  }
}
